Page MenuHomePhabricator

License for pageview data
Closed, ResolvedPublic3 Story Points

Description

The license for the page view data is unclear - should we choose a license (e.g. CC0) and specify it somewhere?

If so, it may be useful to specify a license at the API documentation for API access to page view data:
https://wikimedia.org/api/rest_v1/

Details

Related Gerrit Patches:
mediawiki/services/restbase : masterAdd specific license for pageview end-points

Event Timeline

Nuria created this task.Jul 13 2017, 4:45 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJul 13 2017, 4:45 PM
ZhouZ renamed this task from Pageview data shoudl be served from restbase with a different license to License for pageview data.Jul 13 2017, 5:11 PM
ZhouZ updated the task description. (Show Details)
Pchelolo added a subscriber: Pchelolo.EditedJul 13 2017, 5:21 PM

Thee's a line in the top description:

By using this API, you agree to Wikimedia's Terms of Use and Privacy Policy, and you irrevocably agree to release modifications or additions made through this API under the CC-BY-SA 3.0 License and the GFDL.

Should we tweak the wording?

The general license disclaimer quoted above was added by legal. It focuses on contributions, so doesn't really apply to read-only metrics.

If you would like to change the license for metrics in particular, you can update the per-entrypoint documentation for the metrics end points. The description field supports markdown.

Nuria edited projects, added Analytics-Kanban; removed Analytics.Jul 17 2017, 4:02 PM
Nuria set the point value for this task to 1.
Nuria changed the point value for this task from 1 to 3.
Nuria assigned this task to mforns.Jul 17 2017, 4:22 PM
mforns moved this task from Next Up to In Progress on the Analytics-Kanban board.Jul 18 2017, 4:12 PM
Nuria moved this task from In Progress to Next Up on the Analytics-Kanban board.Jul 19 2017, 12:33 AM
mforns moved this task from Next Up to In Progress on the Analytics-Kanban board.Jul 19 2017, 2:38 PM

Thanks @GWicke!

One question though: I think that the license paragraph in https://wikimedia.org/api/rest_v1/ is not specified in v1/metrics.yaml, but rather in projects/wikimedia.org.yaml. Is that correct?

If so, would it be possible for me to remove the references to CC-BY-SA 3.0 and GFDL from there, and replace them by a reference to CC0? I ask that, because projects/wikimedia.org.yaml includes other endpoints besides the Analytics metrics, namely "Math : formula rendering" and "Transform", which may be subject to the current licenses.

Thanks @GWicke!
One question though: I think that the license paragraph in https://wikimedia.org/api/rest_v1/ is not specified in v1/metrics.yaml, but rather in projects/wikimedia.org.yaml. Is that correct?

Yes, that is the source for the global disclaimer.

If so, would it be possible for me to remove the references to CC-BY-SA 3.0 and GFDL from there, and replace them by a reference to CC0? I ask that, because projects/wikimedia.org.yaml includes other endpoints besides the Analytics metrics, namely "Math : formula rendering" and "Transform", which may be subject to the current licenses.

Licenses differ between end points, so changing the global disclaimer to CC0 doesn't seem accurate. This is why I suggested to add the CC0 license specifically in the metrics end points. For the global disclaimer, my personal favorite would be to remove the second half of that sentence, and just point to the more detailed ToU & privacy policy, as well as the per-entrypoint docs. That is what we had originally, but legal preferred the more explicit mention to make sure people are aware of it.

@GWicke

Licenses differ between end points, so changing the global disclaimer to CC0 doesn't seem accurate. This is why I suggested to add the CC0 license specifically in the metrics end points.

Makes sense. I'm a bit confused, though (sorry if I'm missing something). Is there an exclusive spec UI for the analytics metrics endpoints outside of https://wikimedia.org/api/rest_v1/?

@GWicke Thanks for the explanations!
@ZhouZ and @GWicke I made a mock of the spec with a couple added phrases (enclosed in red square). Please, let me know if it makes sense and would be OK for you.

Change 366852 had a related patch set uploaded (by Mforns; owner: Mforns):
[mediawiki/services/restbase@master] Add specific license for pageview end-points

https://gerrit.wikimedia.org/r/366852

And the related Gerrit patch ^. Thanks!

Nuria added a comment.Jul 21 2017, 3:42 PM

Ping @ZhouZ:Can you OK the text?

Change 366852 abandoned by GWicke:
Add specific license for pageview end-points

Reason:
Closing here, as the review will happen in https://github.com/wikimedia/restbase/pull/848.

https://gerrit.wikimedia.org/r/366852

Nuria added a comment.Aug 1 2017, 4:51 PM

Ping @ZhouZ to leave feedback on ticket

ZhouZ added a comment.EditedAug 1 2017, 9:27 PM

I will provide some proposed language we can add.

Here's a proposed draft that can be used in the header for the REST API documentation of all projects, e.g. https://[Project_URL]/api/rest_v1 (we probably would want to provide a more specific license (CC0) for the Wikidata API documentation but I will track that in a separate task):


Wikimedia REST API

This API provides cacheable and straightforward access to Wikimedia content and data, in machine-readable formats, for the project specified in the URL.

Global Rules
● Limit your clients to no more than 200 requests/s to this API. Each API endpoint’s documentation may detail more specific usage limits.
● Set a unique User-Agent or Api-User-Agent header that allows us to contact you quickly. Email addresses or URLs of contact pages work well.

By using this API, you agree to Wikimedia's Terms of Use and Privacy Policy. See https://www.mediawiki.org/wiki/REST_API for background and details. Unless otherwise specified in the endpoint documentation below, content accessed via this API is licensed under the CC-BY-SA 3.0 license and the GFDL and you irrevocably agree to release modifications or additions made through this API under the CC-BY-SA 3.0 license and the GFDL.

Per endpoint documentation
Please consult each endpoint's documentation for details on:
● Licensing information for the specific type of content served via the endpoint.
● Stability markers to inform you about development status and change policy, according to our API version policy.
● Endpoint specific usage limits.

Authorship
Created by the Wikimedia Services team. See more at http://mediawiki.org/wiki/RESTBase. The API specification is available under the Apache 2.0 license.


ZhouZ added a comment.EditedAug 1 2017, 9:28 PM

Here's the language we can provide at the specific endpoints on the https://wikimedia.org/api/rest_v1/ page. This is an example for the GET /metrics/pageviews endpoint but we should add similar language in the "Implementation Notes" sub-section for all other endpoints in the Pageviews data, Unique devices data, Legacy metrics, and Pagecounts data (legacy) sections on the https://wikimedia.org/api/rest_v1/ page API documentation page.

Note the "Stability" and "Rate limit" values under "Implementation Notes" subsection should remain as before.


GET /metrics/pageviews/
List pageview-related API endpoints.

Implementation Notes
This is the root of all pageview data endpoints. The list of paths that this returns includes ways to query by article, project, top articles, etc. If browsing the interactive documentation, see the specifics for each endpoint below.

  • Stability: stable
  • Rate limit: 100 req/s
  • Data accessible via this endpoint is available under the CC0 1.0 license.

The wording above looks good to me. I think it improves the clarity for all projects.

mobrovac added a subscriber: mobrovac.

The wording looks good to me too, but I have a question. I am probably missing some context, but why does metrics data need a different licence than the rest of the content? Shouldn't we strive at providing all of the data in the same fashion (legally speaking) ?

ZhouZ added a comment.EditedAug 1 2017, 10:14 PM

Hi @mobrovac, without going into the legal weeds, often the license that works best for text content (or software) may not be the most appropriate license for data. For example, data for projects in the Wikimedia movement are usually available under a CC0 license (see the Wikidata license and our open access policy) even if text content for projects like Wikipedia is under a CC BY SA 3.0 license (and images on Wikimedia Commons may also have their own specific license).

Feel free to ping me directly if you have more questions.

Oh I see. Thank you for pointing me to the docs, @ZhouZ !

ZhouZ added a comment.EditedAug 1 2017, 10:44 PM

The API specification is available under the Apache 2.0 license.

Note it is unclear whether we can make this specific change in the text but if possible it would be a good idea to add some context to the current documentation, which merely has a link to the Apache 2 license without further commentary.

HI all, if there are no further objections, are we all ready to move forward with the new proposed language?

Nuria claimed this task.Aug 7 2017, 4:23 PM
Nuria added a subscriber: mforns.

The PR is now updated in line with the discussion.

mobrovac closed this task as Resolved.Aug 7 2017, 9:48 PM
mobrovac edited projects, added Services (done); removed Services (watching).

The PR is now updated in line with the discussion.

It has been merged. Deploy coming soon (this week). Resolving.

Nuria reopened this task as Open.Aug 8 2017, 4:27 AM

Let's keep this open until we have verified changes deployed

Nuria added a comment.Aug 8 2017, 4:23 PM

@mobrovac Please ping on ticket when deployment happens

Pchelolo closed this task as Resolved.Aug 8 2017, 9:11 PM

Deployed. Resolving.

Nuria added a comment.Aug 10 2017, 5:40 PM

Now opening correct ticket, this deploy was reverted (due to unrelated issues) . @Pchelolo to close when licensing code gets deployed again

Nuria reopened this task as Open.Aug 10 2017, 5:40 PM
ZhouZ moved this task from Backlog to Legal Done on the WMF-Legal board.Aug 23 2017, 7:01 PM

Hi @Pchelolo :]
I saw that https://wikimedia.org/api/rest_v1/#/ now has the updated licenses.
Can I move this to done in our board then?
Thanks!

Pchelolo closed this task as Resolved.Aug 29 2017, 4:57 PM

All done here indeed, resolving the ticket.

mforns moved this task from Ready to Deploy to Done on the Analytics-Kanban board.Aug 29 2017, 5:41 PM